require("libs.utils")
local win_msg_hook = nil
local game_start_hook = nil
local hero_player_team_hook = nil
local hero_picker_shown_hook = nil
local game_start_warned = false

function OnWndProc(uMsg, wParam, lParam)
    if uMsg == WM_DotaConfig then
		if wParam == ConfigFlags.dota_force_right_click_attack then
            dota.ConVarSetInt("dota_force_right_click_attack", lParam)
        elseif wParam == ConfigFlags.dota_enable_range_finder then
            dota.ConVarSetInt("dota_enable_range_finder", lParam)
        elseif wParam == ConfigFlags.dota_camera_disable_zoom then
            dota.ConVarSetInt("dota_camera_disable_zoom", lParam)
        elseif wParam == ConfigFlags.net_graph then
            dota.ConVarSetInt("dota_hud_netgraph", lParam)
        elseif wParam == ConfigFlags.anti_run_back then
            dota.ConVarSetFloat("dota_minimap_misclick_time", lParam)
        elseif wParam == ConfigFlags.show_ping then
            if lParam > 0 then
                lua_execute("show_ping.lua")
            else
                lua_unload("show_ping.lua")
            end
        elseif wParam == ConfigFlags.ingame_timer then
            if lParam > 0 then
                lua_execute("ingame_timer.lua")
            else
                lua_unload("ingame_timer.lua")
            end
        elseif wParam == ConfigFlags.tower_range then
            if lParam > 0 then
                lua_execute("tower_range.lua")
            else
                lua_unload("tower_range.lua")
            end
        elseif wParam == ConfigFlags.show_game_paused_timer or wParam == ConfigFlags.auto_send_game_paused_time then
            if lParam > 0 then
                lua_execute("game_paused_timer.lua")
            end
        elseif wParam == ConfigFlags.show_roshan_timer or wParam == ConfigFlags.auto_send_roshan_spawn then
            if lParam > 0 then
                lua_execute("roshan_tips.lua")
            end
        elseif wParam == ConfigFlags.show_rune_timer or wParam == ConfigFlags.show_rune_tips or wParam == ConfigFlags.auto_send_rune_refresh then
            if lParam > 0 then
                lua_execute("rune_tips.lua")
            end
        elseif wParam == ConfigFlags.show_team_health_num or wParam == ConfigFlags.show_team_mana_num or wParam == ConfigFlags.show_team_level or wParam == ConfigFlags.show_enemy_health_num or wParam == ConfigFlags.show_enemy_mana_num or wParam == ConfigFlags.show_enemy_level then
            if lParam > 0 then
                lua_execute("esp.lua")
            end
        elseif wParam == ConfigFlags.dota_always_show_player_names then
            dota.ConVarSetInt("dota_always_show_player_names", lParam)
        elseif wParam == ConfigFlags.dota_health_per_vertical_marker then
            if lParam > 0 then
                dota.ConVarSetInt("dota_health_per_vertical_marker", ReadConfig("dota","dota_health_per_vertical_marker_value","225"))
            else
                dota.ConVarSetInt("dota_health_per_vertical_marker", 250)
            end
        elseif wParam == ConfigFlags.fps_max then
            if lParam > 0 then
                dota.ConVarSetInt("fps_max", ReadConfig("dota","fps_max_value","59"))
            else
                dota.ConVarSetInt("fps_max", 120)
            end
        elseif wParam == ConfigFlags.showconsole then
            if lParam > 0 then
                dota.ExecuteCommand("showconsole")
            else
                dota.ExecuteCommand("hideconsole")
            end
            
		end
	end
	
	if uMsg == WM_KEYDOWN then
		if wParam == VK_P then
    		if (bit.band(GetAsyncKeyState(VK_CONTROL),0x8000) == 0x8000) then
        		local value = (tonumber(ReadConfig("dota","net_graph","0")) == 1) and 0 or 1
                dota.ConVarSetInt("dota_hud_netgraph", value)
                WriteConfig("dota","net_graph",value)
            end
        elseif wParam == VK_F5 then
            --lua_execute("test.lua")
		end
	end
end

function OnPlayerTeam()
    local LoadedPlayers = dota.GameRules:GetInstance():GetLoadedPlayers()
    local ExpectedPlayers = dota.GameRules:GetInstance():GetExpectedPlayers()
    
    log.Warning(string.format("[xxx]%d:%d\n",LoadedPlayers, ExpectedPlayers))
    if (LoadedPlayers == ExpectedPlayers and LoadedPlayers > 0 and game_start_warned == false) then
        log.Warning(string.format("[ooo]%d:%d\n",LoadedPlayers, ExpectedPlayers))
        game_start_warned = true
        BringDotaWindowToTop()
    end 
end

function OnHeroPickerShown()
    BringDotaWindowToTop()
end

function OnMapLoadFinished()
    game_start_warned = false
    --local convar = dota.GlobalInstanceManager:GetCVar():
end

function Initialize()
    win_msg_hook = dota.AddWinMsgHook(OnWndProc)
    game_start_hook = dota.AddMapLoadFinishedHook(OnMapLoadFinished)
    
    --dota.ConVarSetInt("con_enable", 1)

    -- ۿǷ޸ãδøΪĬֵ
    dota.ConVarSetInt("dota_hud_netgraph", ReadConfig("dota","net_graph","0"))
    dota.ConVarSetFloat("dota_minimap_misclick_time", ReadConfig("dota","anti_run_back","0"))
    dota.ConVarSetInt("dota_always_show_player_names", ReadConfig("dota","dota_always_show_player_names","0"))
    dota.ConVarSetInt("dota_force_right_click_attack", ReadConfig("dota","dota_force_right_click_attack","0"))
    dota.ConVarSetInt("dota_enable_range_finder", ReadConfig("dota","dota_enable_range_finder","0"))
    dota.ConVarSetInt("dota_camera_disable_zoom", ReadConfig("dota","dota_camera_disable_zoom","0"))

    
    -- ۿǷ޸ãδøΪֵָ
    if (tonumber(ReadConfig("dota", "dota_health_per_vertical_marker", "0")) > 0) then
        dota.ConVarSetInt("dota_health_per_vertical_marker", ReadConfig("dota","dota_health_per_vertical_marker_value","225"))
    else
        dota.ConVarSetInt("dota_health_per_vertical_marker", 250)
    end

    if (tonumber(ReadConfig("dota", "fps_max", "0")) > 0) then
        dota.ConVarSetInt("fps_max", ReadConfig("dota","fps_max_value","59"))
    else
        dota.ConVarSetInt("fps_max", 120)
    end

    -- ֻпؿŻ޸á
    
    if (tonumber(ReadConfig("dota", "hero_picker_shown", "0")) > 0) then
        --hero_player_team_hook = dota.AddEventListener("player_team", OnPlayerTeam)
        hero_picker_shown_hook = dota.AddEventListener("hero_picker_shown", OnHeroPickerShown)
        lua_execute("game_start_reminder.lua")
    end
    if (tonumber(ReadConfig("dota", "show_game_paused_timer", "0")) > 0) or (tonumber(ReadConfig("dota", "auto_send_game_paused_time", "0")) > 0) then
        lua_execute("game_paused_timer.lua")
    end
    if (tonumber(ReadConfig("dota", "tower_range", "0")) > 0) then
        lua_execute("tower_range.lua")
    end
    if (tonumber(ReadConfig("dota", "show_team_health_num", "0")) > 0) or (tonumber(ReadConfig("dota", "show_team_mana_num", "0")) > 0) or (tonumber(ReadConfig("dota", "show_team_level", "0")) > 0) or (tonumber(ReadConfig("dota", "show_enemy_health_num", "0")) > 0) or (tonumber(ReadConfig("dota", "show_enemy_mana_num", "0")) > 0) or (tonumber(ReadConfig("dota", "show_enemy_level", "0")) > 0) then
        lua_execute("esp.lua")
    end
    if (tonumber(ReadConfig("dota", "ingame_timer", "0")) > 0) then
        lua_execute("ingame_timer.lua")
    end
    if (tonumber(ReadConfig("dota", "show_ping", "0")) > 0) then
        lua_execute("show_ping.lua")
    end
    
--[[
    if (tonumber(ReadConfig("dota","showconsole","0")) > 0) then
        dota.ExecuteCommand("showconsole")
    else
        dota.ExecuteCommand("hideconsole")
    end
]]--
    lua_execute("user_defined.lua")
    log.Warning("autoexec.lua Loaded\n")
    
end
